/*
   Page 6 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.5: Producer/Consumer Threads (Version 1)
*/
#include <stdio.h>
#include <pthread.h>
#include "mythreads.h"
#include "figure_30.4.h"

void *producer(void *arg)
{
   int i;
   int loops = (int) arg;
   for (i = 0; i < loops; i++)
   {
      put(i);
   }
   return NULL; /*** author forgot this ***/
}

void *consumer(void *arg)
{
 //int i;  /*** not needed ***/
   while (1)
   {
      int tmp = get();
      printf("%d\n", tmp);
   }
}


int
main( )
{
   pthread_t p1, p2;
   printf("main: begin\n");
   Pthread_create(&p1, NULL, producer, (void*)20);
   Pthread_create(&p2, NULL, consumer, NULL);
   // join waits for the producer to finish
   Pthread_join(p1, NULL);
   printf("main: end\n");
   return 0;
}